local FunctionFile = debug.FunctionFile


const = const or {}
Const = const

local _KNOWNGLOBALS_F = Game, Party, Keys, keys

local timeGetTime_add = 0
local timeGetTime_last = 0
function timeGetTime()
	local ret = mem.call(internal.timeGetTime, 0)
	if ret < timeGetTime_last then
		timeGetTime_add = timeGetTime_add + 4294967296
	end
	timeGetTime_last = ret
	return ret + timeGetTime_add
end

local timers -- function, period, start,
local LastTick
local sleeps -- coroutine, wake time, realtime wake time, screens

function Timer(f, period, start)
	if start == true then
		start = Game.Time
	end
	table.insert(timers, {f, period or 256, start or 0}) -- Game.Map.LastRefillDay*0x5A000})
end

function Sleep(dt, realtime, screens)
	local c = coroutine.running()
	if c then
		if realtime then
			realtime = timeGetTime() + dt  -- 7.8125 = 1 / 0.128
			dt = 0
		else
			dt = Game.Time + dt
			realtime = 0
		end
		screens = screens or {Game.CurrentScreen}
		table.insert(sleeps, {c, dt, realtime, screens})--, FunctionFile(2)})
		return coroutine.yield(c)
	elseif realtime then
		mem.dll.kernel32.Sleep(dt)
	end
end


function RemoveTimer(f)
	for i = 1, #timers do
		if timers[i][1] == f then
			table.remove(timers, i)
			return
		end
	end
end

local function TimersRemoveFile(f)
	-- f = f or FunctionFile(2)
	-- for i = #timers, 1, -1 do
		-- if FunctionFile(timers[i][1]) == f then
			-- table.remove(timers, i)
		-- end
	-- end
	-- for i = #sleeps, 1, -1 do
		-- if sleeps[i][5] == f then
			-- table.remove(sleeps, i)
		-- end
	-- end
end

function internal.StartTimers()
	timers = {}
	sleeps = sleeps or {}
	internal.SaveGameData.TimerTick = internal.SaveGameData.TimerTick or {}
	LastTick = internal.SaveGameData.TimerTick[mem.string(offsets.MapName)] or -1
end

function internal.TimersSaveGame()
	internal.SaveGameData.TimerTick[mem.string(offsets.MapName)] = LastTick
end

function internal.TimersLeaveMap(t)
	-- for k in pairs(t) do
		-- TimersRemoveFile(k)
	-- end
	timers = {}
	sleeps = {}
	internal.TimersSaveGame()
end

function internal.TimersLeaveGame()
	timers = nil
	sleeps = nil
end

--------- keys

keys = keys or {}
Keys = Keys or {}

function Keys.IsPressed(vk)
	return mem.call(internal.GetKeyState, 0, assertnum(vk, 2)):And(0x8000) ~= 0
end

function Keys.IsToggled(vk)
	return mem.call(internal.GetKeyState, 0, assertnum(vk, 2)):And(1) ~= 0
end

local _, keyHandlers = events.new(Keys)
local pressedKeys = {}

--------- OnTick

local function CallTimers(tick, last)
	for i = #timers, 1, -1 do
		local v = timers[i]
		local dt, start = v[2], v[3]
		if tick >= start and (last < start or (tick - start):div(dt) > (last - start):div(dt)) then
			if dt == 0 then
				table.remove(timers, i)
			end
			coroutine.resume2(coroutine.create(v[1]), last < start)
		end
	end
end

function internal.OnTimer()
	local tick = Game.Time
	if not Game.Paused and not Game.MoveToMap.Defined and timers then
		if tick ~= LastTick then
			CallTimers(tick, LastTick)
			LastTick = tick
		end
	end
	events.cocalls("Tick")
	for k, _ in pairs(keyHandlers) do
		if type(k) == "number" and k > 0 and k <= 255 then
			local wasPressed = pressedKeys[k]
			local pressed = Keys.IsPressed(k)
			pressedKeys[k] = pressed
			if pressed and not wasPressed then
				Keys[k]()
			end
		end
	end
	if sleeps then
		local rtick = timeGetTime()
		local screen = Game.CurrentScreen
		for i = #sleeps, 1, -1 do
			local v = sleeps[i]
			if tick >= v[2] and rtick >= v[3] and (screen == 0 or table.find(v[4], screen)) then
				table.remove(sleeps, i)
				coroutine.resume2(v[1], true)
			end
		end
	end
	if internal.OnWaitMessage then
		internal.OnWaitMessage()
	end
end
